
package agentrouble;

import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.*;

import java.util.*;

public abstract class Calculador extends Agent
{

	AID facilitador;
	MsgTratador tratador;
	
	public static final boolean debug = true;

	protected abstract String getTipo();
	protected abstract java.io.Serializable calcula(Operacao o);
	public abstract void inicializa();
	
	protected void setup()
	{
		tratador = new MsgTratador("calculador", this);
		
		Object[] o = this.getArguments();
		facilitador = (AID) o[0];
		
		ACLMessage msg = tratador.inscricao(facilitador, this.getTipo());
		this.send(msg);

		ACLMessage res = tratador.receber();

		tratador.estouPronto();
		addBehaviour(new ComportamentoCalculador(this));
	}
	protected void takeDown()
	{
		tratador.terminado();
	}
	
	class ComportamentoCalculador extends Behaviour 
	{

		public ComportamentoCalculador(Agent p) {
			super(p);
		}

		public void action()
		{
			ACLMessage msgr = tratador.receberObjeto();

			switch(msgr.getPerformative()) {

				case ACLMessage.REQUEST: {


					try {
						Operacao o = (Operacao) msgr.getContentObject();
						java.io.Serializable res = calcula(o);

						ACLMessage rsp2 = tratador.respondeObjeto(msgr, res);

						ACLMessage rsp1 = tratador.geraAceito(msgr);
						myAgent.send(rsp1);

						myAgent.send(rsp2);
					} catch (jade.lang.acl.UnreadableException e) {
						ACLMessage rsp1 = tratador.geraNegado(msgr);
						myAgent.send(rsp1);
					}
				}
			}
		}

		public boolean done()
		{
			return false;
		}
	}
}
